#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "spec.h"
#include "build.h"
#include "messages.h"
#include "pack.h"
#include "rpmerr.h"

void printerror(void)
{
    fprintf(stderr, "ERRORCODE  : %d\n", errCode());
    fprintf(stderr, "ERRORSTRING: %s\n", errString());
}

void main(int argc, char **argv)
{
    FILE *f;
    Spec s;
    char specfile[1024];
    
    setVerbosity(MESS_VERBOSE);
    errSetCallback(printerror);

    if (argv[1][0] == '/') {
	strcpy(specfile, argv[1]);
    } else {
	getcwd(specfile, 1024);
	strcat(specfile, "/");
	strcat(specfile, argv[1]);
    }

    f = fopen(specfile, "r");
    if ((s = parseSpec(f, specfile))) {
	if (doBuild(s, RPMBUILD_PREP | RPMBUILD_BUILD |
		    RPMBUILD_INSTALL | RPMBUILD_BINARY | RPMBUILD_SOURCE)) {
	    printf("ERROR!\n");
	}
    } else {
	/* Spec parse failed -- could be Exclude: Exclusive: */
	if (errCode() == RPMERR_BADARCH) {
	    printf("%s doesn't build on this architecture\n", argv[1]);
	}
    }
    
    fclose(f);
}
